/*
 * Jalview - A Sequence Alignment Editor and Viewer ($$Version-Rel$$)
 * Copyright (C) $$Year-Rel$$ The Jalview Authors
 * 
 * This file is part of Jalview.
 * 
 * Jalview is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *  
 * Jalview is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty 
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE.  See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jalview.  If not, see <http://www.gnu.org/licenses/>.
 * The Jalview Authors are detailed in the 'AUTHORS' file.
 */
package jalview.ext.rbvi.chimera;

import static org.testng.AssertJUnit.assertEquals;

import java.awt.Color;
import java.util.LinkedHashMap;
import java.util.Map;

import org.testng.annotations.Test;

public class ChimeraCommandsTest
{
  @Test(groups = { "Functional" })
  public void testBuildColourCommands()
  {

    Map<Color, AtomSpecModel> map = new LinkedHashMap<Color, AtomSpecModel>();
    ChimeraCommands.addColourRange(map, Color.blue, 0, 2, 5, "A");
    ChimeraCommands.addColourRange(map, Color.blue, 0, 7, 7, "B");
    ChimeraCommands.addColourRange(map, Color.blue, 0, 9, 23, "A");
    ChimeraCommands.addColourRange(map, Color.blue, 1, 1, 1, "A");
    ChimeraCommands.addColourRange(map, Color.blue, 1, 4, 7, "B");
    ChimeraCommands.addColourRange(map, Color.yellow, 1, 8, 8, "A");
    ChimeraCommands.addColourRange(map, Color.yellow, 1, 3, 5, "A");
    ChimeraCommands.addColourRange(map, Color.red, 0, 3, 5, "A");
    ChimeraCommands.addColourRange(map, Color.red, 0, 6, 9, "A");

    // Colours should appear in the Chimera command in the order in which
    // they were added; within colour, by model, by chain, ranges in start order
    String command = ChimeraCommands.buildColourCommands(map).get(0);
    assertEquals(
            "color #0000ff #0:2-5.A,9-23.A,7.B|#1:1.A,4-7.B; color #ffff00 #1:3-5.A,8.A; color #ff0000 #0:3-9.A",
            command);
  }
}
